// FICHIER EnumTypeGradient.cc


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "EnumTypeGradient.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>


#ifndef  Enum_type_gradient_deja_inclus

#ifndef MISE_AU_POINT
  inline 
#endif
char* Nom_type_gradient (Enum_type_gradient id_nom)
// Retourne le nom du type de gradient associe
// a l'identificateur de type enumere id_nom
{   char* result="";
	switch (id_nom)
	{   case  GRADVITESSE_V_TDT :  result=" GRADVITESSE_V_TDT"; break;
		case GRADVITESSE_VCONST : result="GRADVITESSE_VCONST"; break;
		case GRADVITESSE_VT_VTDT : result="GRADVITESSE_VT_VTDT"; break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_type_gradient !\n";
			cout << "Nom_type_gradient(Enum_type_gradient ) \n";
			Sortie(1);
	};
	return result;	
};

#ifndef MISE_AU_POINT
  inline 
#endif
Enum_type_gradient  Id_nom_type_gradient (char* nom)
// Retourne la variable de type enumere associee au nom du type de gradient
{   Enum_type_gradient result;
	if ( strcmp(nom,"GRADVITESSE_V_TDT")==0 )
		result=GRADVITESSE_V_TDT;
	else if ( strcmp(nom,"GRADVITESSE_VCONST")==0 )
		result=GRADVITESSE_VCONST;
	else if ( strcmp(nom,"GRADVITESSE_VT_VTDT")==0 )
		result=GRADVITESSE_VT_VTDT;
    else
	{   cout << "\nErreur : nom du degre de liberte inconnu !\n";
		cout << "Id_nom_type_gradient (char* nom) \n";
		Sortie(1);
	};
	return result;	
};	

   	
   // surcharge de l'operator de lecture
#ifndef MISE_AU_POINT
  inline 
#endif
istream & operator >> (istream & entree, Enum_type_gradient& a)
 { char nom_Enum_type_gradient[50];
   entree >> nom_Enum_type_gradient;
   a = Id_nom_type_gradient ( nom_Enum_type_gradient);
   return entree;
 };
   
   // surcharge de l'operator d'ecriture
#ifndef MISE_AU_POINT
  inline 
#endif
ostream & operator << (ostream & sort, const Enum_type_gradient& a)
    { // on ecrit la forme caractère
       sort << Nom_type_gradient(a) << " ";
       return sort;      
     }; 

#endif





