// FICHIER : Enum_contrainte_mathematique.cc


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "Enum_contrainte_mathematique.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>



string Nom_contrainte_mathematique (const Enum_contrainte_mathematique id_contrainte_mathematique)
// Retourne le nom de la méthode attachée a l'identificateur 
// de type enumere id_contrainte_mathematique
{
	
   string result;
	switch (id_contrainte_mathematique)
	{
		case MULTIPLICATEUR_DE_LAGRANGE : result="MULTIPLICATEUR_DE_LAGRANGE"; break;
		case PENALISATION : result="PENALISATION"; break;
		case NEWTON_LOCAL : result="NEWTON_LOCAL"; break;
		case PERTURBATION : result="PERTURBATION"; break;
		case RIEN_CONTRAINTE_MATHEMATIQUE : result="RIEN_CONTRAINTE_MATHEMATIQUE"; break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_contrainte_mathematique !: " << id_contrainte_mathematique << " \n";
			cout << "NOM_contrainte_mathematique(Enum_contrainte_mathematique ) \n";
			Sortie(1);
	};
	return result;
	
};
						
Enum_contrainte_mathematique Id_nom_contrainte_mathematique (const string& nom_contrainte_mathematique)
// Retourne la variable de type enumere associee à nom_contrainte_mathematique
{
	
	Enum_contrainte_mathematique result;
	if (  nom_contrainte_mathematique == "MULTIPLICATEUR_DE_LAGRANGE" ) result=MULTIPLICATEUR_DE_LAGRANGE;
	else if (  nom_contrainte_mathematique == "PENALISATION" ) result=PENALISATION;
	else if (  nom_contrainte_mathematique == "NEWTON_LOCAL" ) result=NEWTON_LOCAL;
	else if (  nom_contrainte_mathematique == "PERTURBATION" ) result=PERTURBATION;
	else if (  nom_contrainte_mathematique == "RIEN_CONTRAINTE_MATHEMATIQUE" ) result=RIEN_CONTRAINTE_MATHEMATIQUE;
	else
	{
		cout << "\nErreur : nom de la methode pour imposer la contrainte mathematique inconnue !: " << nom_contrainte_mathematique << " \n";
		cout << "ID_NOM_contrainte_mathematique(string ) \n";
		Sortie(1);
	};
	return result;
	
};

   	
   // surcharge de l'operator de lecture
istream & operator >> (istream & entree, Enum_contrainte_mathematique& a)
 { char nom_Enum_contrainte_mathematique[50];
   entree >> nom_Enum_contrainte_mathematique;
   a = Id_nom_contrainte_mathematique ( nom_Enum_contrainte_mathematique);
   return entree;
 };
   
   // surcharge de l'operator d'ecriture
ostream & operator << (ostream & sort, const Enum_contrainte_mathematique& a)
    { // on ecrit la forme caractère
       sort << Nom_contrainte_mathematique(a) << " ";
       return sort;      
     }; 

	
