// FICHIER Enum_liaison_noeud.cc


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "Enum_liaison_noeud.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"

#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>

string Nom_liaison_noeud (Enum_liaison_noeud id_nom)
// Retourne le nom associe
// a l'identificateur de type enumere id_nom
{
	
	string result="";
	switch (id_nom)
	{
		case PAS_LIER             : result="PAS_LIER"; break;
		case LIER_COMPLET              : result="LIER_COMPLET"; break;
		
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_liaison_noeud !\n";
			cout << "Nom_liaison_noeud(Enum_liaison_noeud ) \n";
			Sortie(1);
	};
	return result;
	
};

Enum_liaison_noeud  Id_nom_liaison_noeud (const string& nom)
// Retourne la variable de type enumere associee au nom
{
	
	Enum_liaison_noeud result;
	if ( nom == "PAS_LIER" )                  result=PAS_LIER;
	else if ( nom == "LIER_COMPLET" )       result=LIER_COMPLET;
 else
   {
    cout << "\nErreur : nom  ** " << nom << " ** du type de liaison inconnu !\n";
    cout << "Id_nom_liaison_noeud (const string&  nom) \n";
    Sortie(1);
   };
	return result;
	
};	


   // surcharge de l'operator de lecture
istream & operator >> (istream & entree, Enum_liaison_noeud& a)
 { string nom_Enum_liaison_noeud;
   entree >> nom_Enum_liaison_noeud;
   a = Id_nom_liaison_noeud ( nom_Enum_liaison_noeud);
   return entree;
 };
   
ostream & operator << (ostream & sort, const Enum_liaison_noeud& a)
     { // on ecrit la forme caractère
       sort << Nom_liaison_noeud(a) << " ";
       return sort;      
     }; 






