// FICHIER : Enum_mat.cp


// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.


#include "Enum_mat.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>



char* Nom_mat (Enum_mat id_mater)
// Retourne le nom du materiau correspondant a l'identificateur 
// de type enumere id_mater
{
	
	char* result;
	switch (id_mater)
	{
		case ACIER :
			result="ACIER";
			break;
		case BETON :
			result="BETON";
			break;
		case COMPOSITE :
			result="COMPOSITE";
			break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_mat !\n";
			cout << "NOM_MAT(Enum_mat ) \n";
			Sortie(1);
	};
	return result;
	
};
						
Enum_mat Id_nom_mat (char* nom_mater)
// Retourne la variable de type enumere associe au nom
// de materiau nom_mater
{
	
	Enum_mat result;
	if ( strcmp(nom_mater,"ACIER")==0 )
		result=ACIER;
	else if ( strcmp(nom_mater,"BETON")==0 )
		result=BETON;
	else if ( strcmp(nom_mater,"COMPOSITE")==0 )
		result=COMPOSITE;
	else
	{
		cout << "\nErreur : nom de materiau inconnu !\n";
		cout << "ID_NOM_MAT(char* ) \n";
		Sortie(1);
	};
	return result;
	
};	

   	
   // surcharge de l'operator de lecture
istream & operator >> (istream & entree, Enum_mat& a)
 { char nom_Enum_mat[150];
   entree >> nom_Enum_mat;
   a = Id_nom_mat ( nom_Enum_mat);
   return entree;
 };
   
   // surcharge de l'operator d'ecriture
ostream & operator << (ostream & sort, const Enum_mat& a)
    { // on ecrit la forme caractère
       sort << Nom_mat(a) << " ";
       return sort;      
     }; 
     
     
     
