// FICHIER : Enum_type_pt_integ.cc

// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.



#include "Enum_type_pt_integ.h"


# include <iostream>
using namespace std;  //introduces namespace std
#include <stdlib.h>
#include "Sortie.h"
//#ifdef SYSTEM_MAC_OS_X
//  #include <stringfwd.h> // a priori ce n'est pas portable
//#el
#if defined  SYSTEM_MAC_OS_CARBON
  #include <stringfwd.h> // a priori ce n'est pas portable
#else  
  #include <string.h> // pour le flot en memoire centrale
#endif
#include <string>



string Nom_Enum_type_pt_integ(const Enum_type_pt_integ id_type_pt_integ)
// Retourne un nom de type de point d'integ a partir de son identificateur de
// type enumere  correspondant
{
	
	string result;
	switch (id_type_pt_integ)
	{
		case PTI_GAUSS : result="PTI_GAUSS"; break;
		case PTI_GAUSS_LOBATTO : result="PTI_GAUSS_LOBATTO"; break;
		default :
			cout << "\nErreur : valeur incorrecte du type Enum_type_pt_integ !\n";
			cout << "Nom_Enum_type_pt_integ(const Enum_type_pt_integ id_type_pt_integ) \n";
			Sortie(1);
	};
	return result;
	
};
						
// Retourne l'identificateur de type enumere associe au nom du type
// d'interpolation 
Enum_type_pt_integ Id_nom_type_pt_integ (const string& nom_type_pt_integ)
{
	
	Enum_type_pt_integ result;
	if (  nom_type_pt_integ == "PTI_GAUSS"  )
		result=PTI_GAUSS;
	else if (  nom_type_pt_integ == "PTI_GAUSS_LOBATTO"  )
		result=PTI_GAUSS_LOBATTO;
	else
	{
		cout << "\nErreur : nom de type de point d'integration inconnu !\n";
		cout << "Id_nom_type_pt_integ (const string nom_type_pt_integ) \n";
		Sortie(1);
	};
	return result;
	
};

// surcharge de la lecture
istream & operator >> (istream & entree, Enum_type_pt_integ & result)
 { string nom_type_pt_integ;
   entree >> nom_type_pt_integ;
   result = Id_nom_type_pt_integ( nom_type_pt_integ);
   return entree;
 };  
 
    
   // surcharge de l'operator d'ecriture
ostream & operator << (ostream & sort, const Enum_type_pt_integ& a)
    { // on ecrit la forme caractère
       sort << Nom_Enum_type_pt_integ(a) << " ";
       return sort;      
     }; 
	
