// This file is part of the Herezh++ application.
//
// The finite element software Herezh++ is dedicated to the field
// of mechanics for large transformations of solid structures.
// It is developed by Gérard Rio (APP: IDDN.FR.010.0106078.000.R.P.2006.035.20600)
// INSTITUT DE RECHERCHE DUPUY DE LÔME (IRDL) <https://www.irdl.fr/>.
//
// Herezh++ is distributed under GPL 3 license ou ultérieure.
//
// Copyright (C) 1997-2021 Université Bretagne Sud (France)
// AUTHOR : Gérard Rio
// E-MAIL  : gerardrio56@free.fr
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty
// of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.
//
// For more information, please consult: <https://herezh.irdl.fr/>.

/************************************************************************
 *     DATE:        23/01/97                                            *
 *                                                                $     *
 *     AUTEUR:      G RIO   (mailto:gerardrio56@free.fr)                *
 *                                                                $     *
 *     PROJET:      Herezh++                                            *
 *                                                                $     *
 ************************************************************************
 *     BUT: création d'un conteneur vector stl, qui comporte en plus    *
 *     une surcharge de lecture écriture.                               *
 *                                                                $     *
 *     ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''     *
 *                                                                $     *
 ************************************************************************/
#ifndef VECTOR_IO_H
#define VECTOR_IO_H

#include <iostream>
#include <stdlib.h>
#include <vector>
#include "Sortie.h"

/**
*
*     BUT: création d'un conteneur vector stl, qui comporte en plus
*     une surcharge de lecture écriture.
*
*
* \author    Gérard Rio
* \version   1.0
* \date      23/01/97
* \brief       création de conteneurs type vector stl avec surcharge de lecture écriture
*
*/

template <class T>
class Vector_io : public vector<T>
{  // surcharge de l'operator de lecture
   friend istream & operator >> (istream & entree, Vector_io& )
     { cout << "erreur, cette surcharge ne doit pas être utilisée "
            << "Vector_io, operator >> \n"; 
       Sortie(1);
       return entree;
      }       
   // surcharge de l'operator d'ecriture
   friend ostream & operator << (ostream & sort, const Vector_io& )
     { cout << "erreur, cette surcharge ne doit pas être utilisée "
            << "VectorVector_io, operator << \n"; 
       Sortie(1);
       return sort;
      }       

  public :
    // CONSTRUCTEURS :
    
    // DESTRUCTEUR :
    
    // METHODES PUBLIQUES :
    
  private :  
    // VARIABLES PROTEGEES :
    
    // CONSTRUCTEURS :
    
    // DESTRUCTEUR :
    
    // METHODES PROTEGEES :

 };
 
#endif  
